diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 22efccf38..23cdecf3c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -20,22 +20,38 @@ public class ItemBed extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        TilePosc pos = blockPos;
-        if (!world.canPlaceInsideBlock(pos)) {
-            pos = pos.add(side.getDirection(), new TilePos());
+        if (selfStack.stackSize <= 0) return false;
+        TilePosc pos1 = blockPos;
+        if (!world.canPlaceInsideBlock(pos1)) {
+            pos1 = new TilePos(pos1).add(side.getDirection());
         }
         Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).getOpposite();
-        TilePos pos2 = pos.sub(dir, new TilePos());
-        if (world.isAirBlock(pos) && world.isAirBlock(pos2) && world.canPlaceOnSurfaceOfBlock(pos.down(new TilePos())) && world.canPlaceOnSurfaceOfBlock(pos2.down(new TilePos()))) {
-            if (world.canBlockIdBePlacedAt(Blocks.BED.id(), pos, false, side) && selfStack.consumeItem(player)) {
-                world.playBlockSoundEffect(player, pos.x() + 0.5F, pos.y() + 0.5F, pos.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
-                world.setBlockTypeData(pos, Blocks.BED, dir.getHorizontalIndex());
-                world.setBlockTypeData(pos2, Blocks.BED, dir.getHorizontalIndex() | BlockLogicBed.MASK_IS_HEAD);
-                world.notifyBlockChange(pos, Blocks.BED);
-                world.notifyBlockChange(pos2, Blocks.BED);
-                return true;
-            }
+        final TilePos pos2 = new TilePos(pos1).sub(dir);
+        
+        if (!world.canPlaceInsideBlock(pos1) || !world.canPlaceInsideBlock(pos2)) return false;
+        
+        final TilePos qpos = new TilePos();
+        if (!world.canPlaceOnSurfaceOfBlock(qpos.set(pos1).down())) return false;
+        if (!world.canPlaceOnSurfaceOfBlock(qpos.set(pos2).down())) return false;
+        
+        if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos1, false, side)) return false;
+        // if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos2, false, side)) return false;
+        
+        
+        final boolean isPlaced1 = 
+        world.setBlockTypeData(pos1, Blocks.BED, dir.getHorizontalIndex());
+        final boolean isPlaced2 = isPlaced1 &&
+        world.setBlockTypeData(pos2, Blocks.BED, dir.getHorizontalIndex() | BlockLogicBed.IS_HEAD.set(0, 1));
+        if (!isPlaced2) {
+            if (isPlaced1) world.setBlockType(pos1, Blocks.AIR);
+            return false;
         }
-        return false;
+        selfStack.consumeItem(player);
+
+        world.notifyBlockChange(pos1, Blocks.BED);
+        world.notifyBlockChange(pos2, Blocks.BED);
+
+        world.playBlockSoundEffect(player, pos1.x() + 0.5F, pos1.y() + 0.5F, pos1.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
+        return true;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index aa381176a..d6fb92c73 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -65,16 +65,17 @@ public class ItemDoor extends Item {
             return false;
         }
 
-        world.noNeighborUpdate = true;
-        world.setBlockTypeDataNotify(blockPos, this.doorBlockBottom, meta);
-        world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.doorBlockTop, meta);
-        world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom);
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop);
-        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+        world.setBlockTypeData(blockPos, this.doorBlockBottom, meta);
+        world.setBlockTypeData(blockPos.up(new TilePos()), this.doorBlockTop, meta);
+        selfStack.consumeItem(player);
+
         this.doorBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.doorBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
-        selfStack.consumeItem(player);
+
+        world.notifyBlockChange(blockPos, this.doorBlockBottom);
+        world.notifyBlockChange(blockPos.up(new TilePos()), this.doorBlockTop);
+
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         return true;
     }
 
@@ -118,15 +119,16 @@ public class ItemDoor extends Item {
             return;
         }
 
-        world.noNeighborUpdate = true;
-        world.setBlockTypeDataNotify(blockPos, this.doorBlockBottom, meta);
-        world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.doorBlockTop, meta);
-        world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom);
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop);
-        world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+        world.setBlockTypeData(blockPos, this.doorBlockBottom, meta);
+        world.setBlockTypeData(blockPos.up(new TilePos()), this.doorBlockTop, meta);
+        selfStack.consumeItem(null);
+
         this.doorBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
         this.doorBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
-        selfStack.consumeItem(null);
+
+        world.notifyBlockChange(blockPos, this.doorBlockBottom);
+        world.notifyBlockChange(blockPos.up(new TilePos()), this.doorBlockTop);
+        
+        world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index fb4726bc3..c00177e8f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -67,7 +67,7 @@ public class ItemFlag extends Item {
         }
 
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.FLAG, EnumBlockSoundEffectType.PLACE);
-        world.setBlockTypeNotify(blockPos, Blocks.FLAG);
+        world.setBlockType(blockPos, Blocks.FLAG);
 
         selfStack.consumeItem(player);
         if (world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
@@ -80,6 +80,7 @@ public class ItemFlag extends Item {
                 player.displayFlagEditorScreen(flag);
             }
         }
+        world.notifyBlockChange(blockPos, Blocks.FLAG);
         return true;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index bc5ba2bdb..bbe148998 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -38,7 +38,7 @@ public class ItemPlaceable extends Item {
             return false;
         }
         if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockTypeNotify(blockPos, this.blockToPlace)) {
+            if (world.setBlockType(blockPos, this.blockToPlace)) {
                 if (player == null) {
                     this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
@@ -50,6 +50,10 @@ public class ItemPlaceable extends Item {
                         tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
                     }
                 }
+                // notify self change after onPlacedByMob
+                // this should fix almost all bugs related to piston intercepting placement logic,
+                // with out change to individual onPlaced<_> logics.
+                world.notifyBlockChange(blockPos, this.blockToPlace);
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
index a4f2f8511..53bf94e5f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -48,12 +48,13 @@ public class ItemRope extends ItemPlaceable {
             return false;
         }
         if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), bp, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockTypeDataNotify(bp, this.blockToPlace, placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
+            if (world.setBlockTypeData(bp, this.blockToPlace, placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
                 if (player == null) {
                     this.blockToPlace.onPlacedOnSide(world, bp, side, xHit, yHit);
                 } else {
                     this.blockToPlace.onPlacedByMob(world, bp, side, player, xHit, yHit);
                 }
+                world.notifyBlockChange(bp, this.blockToPlace);
                 world.playBlockSoundEffect(player, bp.x + 0.5F, bp.y + 0.5F, bp.z + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index 36a62aa52..66a35f6c4 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item;
 
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.player.Player;
@@ -33,14 +34,16 @@ public class ItemSign extends Item {
             return false;
         }
 
+        final Block<?> blockPlaced;
         if (side == Side.TOP) {
-            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_POST_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+            blockPlaced = Blocks.SIGN_POST_PLANKS_OAK;
+            world.setBlockTypeData(blockPos, blockPlaced, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         } else {
-            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK, side.getId());
+            blockPlaced = Blocks.SIGN_WALL_PLANKS_OAK;
+            world.setBlockTypeData(blockPos, blockPlaced, side.getId());
         }
         selfStack.consumeItem(player);
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, blockPlaced, EnumBlockSoundEffectType.PLACE);
         if (world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if (selfStack.getData().containsKey("tileEntityData")) {
                 sign.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
@@ -49,6 +52,7 @@ public class ItemSign extends Item {
                 player.displaySignEditorScreen(sign);
             }
         }
+        world.notifyBlockChange(blockPos, blockPlaced);
         return true;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
index a431013e7..f73ba4d5a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.player.Player;
@@ -31,16 +32,18 @@ public class ItemSignPainted extends ItemSign {
         if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK_PAINTED.canPlaceAt(world, blockPos)) {
             return false;
         }
-
+        
+        final Block<?> blockPlaced;
         if (side == Side.TOP) {
             int direction = MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf;
-            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
-            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | direction);
+            blockPlaced = Blocks.SIGN_POST_PLANKS_OAK_PAINTED;
+            world.setBlockTypeData(blockPos, blockPlaced, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | direction);
         } else {
-            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
-            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.getId());
+            blockPlaced = Blocks.SIGN_WALL_PLANKS_OAK_PAINTED;
+            world.setBlockTypeData(blockPos, blockPlaced, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.getId());
         }
         selfStack.consumeItem(player);
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, blockPlaced, EnumBlockSoundEffectType.PLACE);
         if (world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if (selfStack.getData().containsKey("tileEntityData")) {
                 sign.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
@@ -49,6 +52,7 @@ public class ItemSignPainted extends ItemSign {
                 player.displaySignEditorScreen(sign);
             }
         }
+        world.notifyBlockChange(blockPos, blockPlaced);
         return true;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
index b60c5d684..59e3381a7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -36,13 +36,10 @@ public class ItemStatue extends Item {
             return false;
         }
 
-        world.noNeighborUpdate = true;
-        world.setBlockTypeDataNotify(blockPos, this.statueBlockBottom, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-        world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.statueBlockTop, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-        world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom);
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop);
-        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
+        world.setBlockTypeData(blockPos, this.statueBlockBottom, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        world.setBlockTypeData(blockPos.up(new TilePos()), this.statueBlockTop, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        selfStack.consumeItem(player);
+        
         this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.statueBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
 
@@ -52,8 +49,11 @@ public class ItemStatue extends Item {
                 tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
             }
         }
+        world.notifyBlockChange(blockPos, this.statueBlockBottom);
+        world.notifyBlockChange(blockPos.up(new TilePos()), this.statueBlockTop);
+        
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
 
-        selfStack.consumeItem(player);
         return true;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index 18351c234..7169216c3 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
@@ -33,44 +34,58 @@ public class ItemBlock<T extends BlockLogic> extends Item {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        final int meta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
+        return this.placeWithMeta(selfStack, world, player, blockPos, meta, side, xHit, yHit);
+    }
+
+    public final boolean placeWithMeta(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, int meta, @NotNull Side side, double xHit, double yHit
+    ) {
         if (selfStack.stackSize <= 0) {
             return false;
         }
-        if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
-        }
-        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
-            return false;
+        final boolean placeNextToExisting = !world.canPlaceInsideBlock(blockPos) ||
+            (this.block.hasTag(BlockTags.PLACE_OVERWRITES) && this.block == world.getBlockType(blockPos));
+
+        if (placeNextToExisting) blockPos = blockPos.add(side.getDirection(), new TilePos());
+
+        if (!world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) return false;
+        
+        if (!world.setBlockTypeData(blockPos, this.block, meta)) return false;
+        if (!selfStack.consumeItem(player)) return false; // should always be true
+
+        if (player == null) {
+            this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+        } else {
+            this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         }
-        if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-            int meta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if (world.setBlockTypeDataNotify(blockPos, this.block, meta)) {
-                if (player == null) {
-                    this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-                } else {
-                    this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-                }
-                if (this.block.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-                    TileEntity tileEntity = world.getTileEntity(blockPos);
-                    if (tileEntity != null) {
-                        tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-                    }
-                }
-                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-                return true;
-            } else if (player == null || player.getGamemode().hasBlockConsumption()) {
-                selfStack.stackSize += 1;
+
+        if (this.block.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+            final TileEntity tileEntity = world.getTileEntity(blockPos);
+            if (tileEntity != null) {
+                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
             }
         }
-        return false;
+
+        world.notifyBlockChange(blockPos, this.block);
+        world.playBlockSoundEffect(
+            player,
+            blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F,
+            this.block, EnumBlockSoundEffectType.PLACE
+        );
+        return true;
     }
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlockType(blockPos);
-        if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+        blockPos = new TilePos(blockPos).add(direction);
+        @NotNull Block<?> b = world.getBlockType(blockPos);
+        if (b == Blocks.AIR || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
             onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index 8694aaf19..829a4db67 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -2,11 +2,11 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.FluidWater;
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -34,40 +34,39 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T> {
 
     @Override
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
-        double reachDistance = player.getGamemode().getBlockReachDistance();
-        HitResult rayCast = player.rayCast(reachDistance, 1f, true, false, false);
-        if (rayCast == null) {
-            return selfStack;
-        }
-        if (rayCast instanceof HitResult.Tile hitTile) {
-            TilePos blockPos = new TilePos(hitTile.tilePos);
-            if (world.getBlockType(blockPos) == Blocks.FLUID_WATER_STILL) {
-                blockPos.y++;
-            } else {
-                return selfStack;
-            }
+        final double reachDistance = player.getGamemode().getBlockReachDistance();
+        final HitResult rayCast = player.rayCast(reachDistance, 1f, true, false, false);
+        if (!(rayCast instanceof HitResult.Tile hitTile)) return selfStack;
 
-            if (world.getBlockType(blockPos) != Blocks.AIR) {
-                return selfStack;
-            }
-            if (selfStack.consumeItem(player) && world.setBlockTypeNotify(blockPos, this.block)) {
-                this.block.onPlacedByMob(world, blockPos, Side.NONE, player, 0.5, 0.5);
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-                player.swingItem();
-            }
-        }
+        final var pos = new TilePos(hitTile.tilePos);
+        if (!testPlace(world, pos)) return selfStack;
+
+        super.onUseOnBlock(selfStack, world, player, pos, Side.NONE, 0.5, 0.5);
         return selfStack;
     }
-
+    
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction, new TilePos());
-        TilePos up = blockPos.up(new TilePos());
-        Block<?> b = world.getBlockType(blockPos);
-        Block<?> bAbove = world.getBlockType(up);
-        if (b == Blocks.FLUID_WATER_STILL && (bAbove == null || bAbove.hasTag(BlockTags.PLACE_OVERWRITES))) {
-            world.setBlockTypeNotify(up, this.block);
-            this.block.onPlacedOnSide(world, up, Side.NONE, 0.5, 0.5);
-        }
+        
+        final var pos = new TilePos(blockPos).add(direction);
+        if (!testPlace(world, pos)) return;
+        
+        if (!world.setBlockType(pos, this.block)) return;
+        selfStack.consumeItem(null);
+
+        this.block.onPlacedOnSide(world, pos, Side.NONE, 0.5, 0.5);
+        world.notifyBlockChange(pos, this.block);
+    }
+
+    private static final boolean testPlace(@NotNull World world, @NotNull TilePos toMove) {
+        final TilePos origin = new TilePos(toMove);
+
+        @NotNull Block<?> up = world.getBlockType(toMove.up());
+        if (up != Blocks.AIR) return false;
+
+        if (!(world.getBlockType(origin).getLogic() instanceof BlockLogicFluid fluid)) return false;
+        if (!(fluid.fluid instanceof FluidWater)) return false;
+        if (fluid.getDepth(world, origin) != 0) return false;
+        return true;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index 99ea24a7b..e7a7a2cca 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -3,7 +3,6 @@ package net.minecraft.core.item.block;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLadder;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -20,55 +19,23 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        TilePos bp = new TilePos(blockPos);
-        Block<?> clickedBlock = world.getBlockType(bp);
-
-        BlockLogicLadder ladder = this.block.getLogic();
-
-        if (clickedBlock == this.block && player != null && !player.isSneaking()) {
-            Side clickedLadderSide = ladder.getSideFromMeta(world.getBlockData(bp));
-            while (world.getBlockType(bp) == this.block && ladder.getSideFromMeta(world.getBlockData(bp)) == clickedLadderSide)
-                bp.y--;
-            int meta = ladder.getMetaForSide(clickedLadderSide);
-            if (ladder.canExistAt(world, new TilePos(bp), meta)) {
-                return placeBlock(selfStack, world, bp, meta, player, clickedLadderSide, 0.5, 0.5);
+        final TilePos bp = new TilePos(blockPos);
+        final @NotNull BlockLogicLadder ladder = this.block.getLogic();
+
+        final Side pside;
+        if (player == null || player.isSneaking() || world.getBlockType(bp) != this.block) {
+            if (!world.canPlaceInsideBlock(bp)) bp.add(side.getDirection());
+            pside = ladder.getSideForPlacement(world, bp, side);
+        } else {
+            xHit = 0.5;
+            yHit = 0.5;
+            pside = ladder.getSideFromMeta(world.getBlockData(bp));
+            while (world.getBlockType(bp) == this.block && ladder.getSideFromMeta(world.getBlockData(bp)) == pside) {
+                bp.down();
             }
-
-            return false;
-        }
-
-        if (!world.canPlaceInsideBlock(bp)) {
-            bp = bp.add(side.getDirection(), new TilePos());
-        }
-
-        Side sideForPlacement = ladder.getSideForPlacement(world, bp, side);
-        if (sideForPlacement == null) {
-            return false;
-        }
-
-        int meta = ladder.getMetaForSide(sideForPlacement);
-        if (ladder.canExistAt(world, bp, meta)) {
-            return placeBlock(selfStack, world, bp, meta, player, sideForPlacement, xHit, yHit);
         }
-
-        return false;
-    }
-
-
-    public boolean placeBlock(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TilePos tilePos, int meta, @Nullable Player player, @NotNull Side side, double xHit, double yHit) {
-        if (world.canPlaceInsideBlock(tilePos) && world.canBlockIdBePlacedAt(this.block.id(), tilePos, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockTypeDataNotify(tilePos, this.block, meta)) {
-                if (player == null) {
-                    this.block.onPlacedOnSide(world, tilePos, side, xHit, yHit);
-                } else {
-                    this.block.onPlacedByMob(world, tilePos, side, player, xHit, yHit);
-                }
-                world.playBlockSoundEffect(player, tilePos.x + 0.5f, tilePos.y + 0.5f, tilePos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
-                return true;
-            }
-        }
-        return false;
+        final var meta = ladder.getMetaForSide(pside);
+        if (!ladder.canExistAt(world, bp, meta)) return false;
+        return super.placeWithMeta(selfStack, world, player, bp, meta, pside, xHit, yHit);
     }
-
-
 }
